Attribute VB_Name = "SubClasser"
Option Explicit
Private Const MyName As String = "Subclasser"

'  : SubClassItem, ISubclass
' ,   :

'============== SubClassItem.cls code ==============
'Option Explicit
'Public hWnd As Long
'Public CallObject As ISubclass
'Public TransferHow As TransferMessageConstants
'Public PrevProc As Long
'===================================================

'=============== ISubclass.cls code ================
'Option Explicit
'Public Function Callback(ByVal hWnd As Long, ByRef uMsg As Long, ByRef wParam As Long, ByRef lParam As Long, ByVal PrevProc As Long) As Long
'End Function
'===================================================

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" ( _
                                            ByVal hWnd As Long, _
                                            ByVal nIndex As Long, _
                                            ByVal dwNewLong As Long) As Long

Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" ( _
                                            ByVal lpPrevWndFunc As Long, _
                                            ByVal hWnd As Long, _
                                            ByVal Msg As Long, _
                                            ByVal wParam As Long, _
                                            ByVal lParam As Long) As Long
Private Const GWL_WNDPROC = -4
Private mCol As New Collection

Enum TransferMessageConstants
  DoNotTransfer   '      ,
                  '     ,  
                  ' .     .
  TransferBefore  '      
  TransferAfter   '      
End Enum

'=========================================
'   :
'=========================================
'hWnd             - hWnd ,    .    
'MessageProcessor - ,    ISubclass
'TransferType     - ,    .
'                       TransferMessageConstants

Public Function AddSubclassHook(ByVal hWnd As Long, ByVal MessageProcessor As ISubclass, ByVal TransferType As TransferMessageConstants) As Boolean
  Dim objNewMember As SubClassItem
  
  If hWnd Then
    If MessageProcessor Is Nothing Then
      Err.Raise 5, MyName, "Invalid callback interface"
    Else
      Set objNewMember = New SubClassItem
      With objNewMember
        Set .CallObject = MessageProcessor
        .hWnd = hWnd
        .TransferHow = TransferType
        ' WndProc    null,    
        ' ,   SetLastError  
        mCol.Add objNewMember, CStr(hWnd)
        .PrevProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf SubClasser.WindowProc)
        If .PrevProc = 0 Then mCol.Remove CStr(hWnd): Err.Raise 5, MyName, "Invalid hWnd"
      End With
      AddSubclassHook = True
    End If
  Else
    Err.Raise 5, MyName, "Invalid hWnd"
  End If
End Function

Public Function RemoveSubclassHook(ByVal hWnd As Long) As Boolean
  Dim tmpHook As SubClassItem
  
  Set tmpHook = Item(hWnd)
  
  If Not tmpHook Is Nothing Then
    SetWindowLong tmpHook.hWnd, GWL_WNDPROC, tmpHook.PrevProc
    mCol.Remove CStr(hWnd)
    Set tmpHook.CallObject = Nothing
    Set tmpHook = Nothing
  End If
  RemoveSubclassHook = True
End Function

Private Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Dim CurHook As SubClassItem
  
  Set CurHook = mCol(CStr(hWnd)) '   ;)
  
  Select Case CurHook.TransferHow
  Case DoNotTransfer
    '   .  ,   .
    WindowProc = CurHook.CallObject.Callback(hWnd, uMsg, wParam, lParam, CurHook.PrevProc)
  Case TransferBefore
    '  .    ,  .
    WindowProc = CallWindowProc(CurHook.PrevProc, hWnd, uMsg, wParam, lParam)
    If CurHook.CallObject Is Nothing Then Set CurHook = Nothing Else CurHook.CallObject.Callback hWnd, uMsg, wParam, lParam, 0
  Case TransferAfter
    '  .    ,  ByRef,
    '      .
    CurHook.CallObject.Callback hWnd, uMsg, wParam, lParam, 0
    WindowProc = CallWindowProc(CurHook.PrevProc, hWnd, uMsg, wParam, lParam)
  End Select
  
  '    CurHook?
  ',      .
  ' 1     2   TransferBefore
  ' 2     (RemoveAll)
  
  '     :
  '  1.   1.  .
  '  2.   2.   ,    
  '     Command2_Click.  .
  '      -      WindowProc!
  '      -  !  , CurHook.CallObject = Nothing.
  '         ,  ...
  
  ',      ,   
End Function

Public Sub RemoveAll()
  Dim tmpHook As SubClassItem
  
  For Each tmpHook In mCol
    RemoveSubclassHook tmpHook.hWnd
  Next
End Sub

Public Function AlreadyOurs(ByVal hWnd As Long) As Boolean
  ' ...        
  AlreadyOurs = Not Item(hWnd) Is Nothing
End Function

Private Function Item(ByVal hWnd As Long) As SubClassItem
  On Error Resume Next
  Set Item = mCol(CStr(hWnd))
End Function
